#ifndef IMPORT_H
#define IMPORT_H

#include "util/region.h"

struct ASDF_;

/*  import_vol
 *
 *  Imports a .vol file, given side lengths and scale.
 */
struct ASDF_* import_vol(const char* filename,
                         int ni, int nj, int nk,
                         const float offset, const float mm_per_voxel);
                 
/*  build_from_vol
 *
 *  Recursively constructs an ASDF from a set of density values.
 */
struct ASDF_* build_from_vol(float*** data, Region region);

#endif