#ifndef PRINTERS_H
#define PRINTERS_H

#include <stdio.h>

struct Node_;

/*  print_node
 *
 *  Recursively prints a node to standard output.
 */
void print_node(struct Node_* n);


/*  fprint_node
 *
 *  Recursively prints a node to a given file descriptor
 */
void  fprint_node(struct Node_* n, int fd);
void _fprint_node(struct Node_* n, FILE* f);

////////////////////////////////////////////////////////////////////////////////

void add_p(struct Node_* n, FILE* f);
void sub_p(struct Node_* n, FILE* f);
void mul_p(struct Node_* n, FILE* f);
void div_p(struct Node_* n, FILE* f);

void min_p(struct Node_* n, FILE* f);
void max_p(struct Node_* n, FILE* f);

void pow_p(struct Node_* n, FILE* f);

////////////////////////////////////////////////////////////////////////////////

void square_p(struct Node_* n, FILE* f);
void sqrt_p(struct Node_* n, FILE* f);
void sin_p(struct Node_* n, FILE* f);
void cos_p(struct Node_* n, FILE* f);
void tan_p(struct Node_* n, FILE* f);
void neg_p(struct Node_* n, FILE* f);
void buf_p(struct Node_* n, FILE* f);

////////////////////////////////////////////////////////////////////////////////

void constant_p(struct Node_* n, FILE* f);
void X_p(struct Node_* n, FILE* f);
void Y_p(struct Node_* n, FILE* f);
void Z_p(struct Node_* n, FILE* f);

#endif